<?php
class Personnage
{
    private int $force;
    private int $experience; // def: 0
    private int $degats; // def: 0
    private array $localisation; // def: x=0, y=0

    public function __construct(
        int $force,
        array $localisation = ['x' => 0, 'y' => 0],
        int $experience = 0,
        int $degats = 0
    ) {
        $this->force = $force;
        $this->experience = $experience;
        $this->degats = $degats;
        $this->localisation = $localisation;
    }

    public function printInfo(): void
    {
        echo "Force : " . $this->force . "<br>";
        echo "Expérience : " . $this->experience . "<br>";
        echo "Dégâts : " . $this->degats . "<br>";
        echo "Localisation : x = " . $this->localisation['x'] .
            ", y = " . $this->localisation['y'] . "<br>";
        echo "<br>";
    }

    public function parler($discours): void
    {
        echo $discours;
        echo "<br>";
    }

    public function experience(): int
    {
        return $this->experience;
    }

    public function gagnerExperience($exp): void
    {
        $this->experience += $exp;
    }
}
